unit uDivModDemo;

{ **************************************************************************** }
{ **************************************************************************** }

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    PnlUeberschrift: TPanel;
    LblDividend: TLabel;
    EdtDividend: TEdit;
    LblDivisor: TLabel;
    EdtDivisor: TEdit;
    BtnDiv: TButton;
    BtnSlash: TButton;
    BtnMod: TButton;
    LblAusgabe: TLabel;
    EdtAusgabe: TEdit;
    GrpBoxEingabe: TGroupBox;
    GrpBoxAusgabe: TGroupBox;
    GrpBoxVerarbeitung: TGroupBox;
    BitBtnReset: TBitBtn;
    BitBtnInfo: TBitBtn;
    BitBtnClose: TBitBtn;
    procedure BitBtnCloseClick(Sender: TObject);
    procedure BitBtnInfoClick(Sender: TObject);
    procedure BtnDivClick(Sender: TObject);
    procedure BtnModClick(Sender: TObject);
    procedure BtnSlashClick(Sender: TObject);
    procedure BitBtnResetClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

{ **************************************************************************** }
{ **************************************************************************** }

implementation

{$R *.dfm}

procedure TForm1.BtnDivClick(Sender: TObject);
var
  Dividend,Divisor,Ergebnis: Integer;
begin
  { Eingabe }
  Dividend := StrToInt(EdtDividend.Text);
  Divisor := StrToInt(EdtDivisor.Text);

  { Verarbeitung (Berechnung) }
  Ergebnis := Dividend div Divisor;

  { Ausgabe }
  LblAusgabe.Caption := 'Div-Ergebnis:';
  EdtAusgabe.Text := IntToStr(Ergebnis);
end;

{ **************************************************************************** }

procedure TForm1.BtnModClick(Sender: TObject);
var
  Dividend,Divisor,Ergebnis: Integer;
begin
  { Eingabe }
  Dividend := StrToInt(EdtDividend.Text);
  Divisor := StrToInt(EdtDivisor.Text);

  { Verarbeitung (Berechnung) }
  Ergebnis := Dividend mod Divisor;

  { Ausgabe }
  LblAusgabe.Caption := 'Mod-Ergebnis:';
  EdtAusgabe.Text := IntToStr(Ergebnis);
end;

{ **************************************************************************** }

procedure TForm1.BtnSlashClick(Sender: TObject);
var
  Dividend,Divisor,Ergebnis: Real;
begin
  { Eingabe }
  Dividend := StrToFloat(EdtDividend.Text);
  Divisor := StrToFloat(EdtDivisor.Text);

  { Verarbeitung (Berechnung) }
  Ergebnis := Dividend / Divisor;

  { Ausgabe }
  LblAusgabe.Caption := '/-Ergebnis (mit 4 Dezimalen):';
  EdtAusgabe.Text := FloatToStrF(Ergebnis,ffFixed,8,4);
end;

{ **************************************************************************** }

procedure TForm1.BitBtnResetClick(Sender: TObject);
begin
  LblAusgabe.Caption := 'Ausgabe:';
  EdtDividend.Text := '';
  EdtDivisor.Text := '';
  EdtAusgabe.Text := '';    
end;

{ **************************************************************************** }

procedure TForm1.BitBtnInfoClick(Sender: TObject);
begin
  MessageDlg('Div-/Mod-Demo (V1.0)' + #13 +
    'Programm zur Demonstration der Divisionsfunktionen Div, Mod und /.' + #13 + #13 +
    'M. Zirbes, 2021' + #13 + #13 +
    'Bei diesem Programm handelt es sich um Freeware,' + #13 +
    'd.h. es steht zur kostenlosen Nutzung frei zur Verfgung' + #13 +
    'und darf ohne Entgelt vervielfltigt und verbreitet werden.' + #13 + #13 +
    'Kontakt: schule@mijozi.de',mtInformation,[mbOK],0);
end;

{ **************************************************************************** }

procedure TForm1.BitBtnCloseClick(Sender: TObject);
begin
  Close;
end;

{ **************************************************************************** }
{ **************************************************************************** }

end.
